// (C) Copyright 2002-2007 by Autodesk, Inc. 
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//

//-----------------------------------------------------------------------------
//----- acrxEntryPoint.cpp
//-----------------------------------------------------------------------------
#include "StdAfx.h"
#include "resource.h"
#include "Utils.h"


//-----------------------------------------------------------------------------
#define szRDS _RXST("Adsk")

//-----------------------------------------------------------------------------
//----- ObjectARX EntryPoint
class CArxTest1App : public AcRxArxApp {

public:
	CArxTest1App () : AcRxArxApp () {}

	virtual AcRx::AppRetCode On_kInitAppMsg (void *pkt) {
		// TODO: Load dependencies here

		// You *must* call On_kInitAppMsg here
		AcRx::AppRetCode retCode =AcRxArxApp::On_kInitAppMsg (pkt) ;
		
		return (retCode) ;
	}

	virtual AcRx::AppRetCode On_kUnloadAppMsg (void *pkt) {
		// TODO: Add your code here

		// You *must* call On_kUnloadAppMsg here
		AcRx::AppRetCode retCode =AcRxArxApp::On_kUnloadAppMsg (pkt) ;

		return (retCode) ;
	}

	virtual void RegisterServerComponents () 
	{
	}
	
	// Usage : AttReplace <Attribute Tag name> <Old Value> <New Value>
	// Select Lights.dwg
	// (command "AttReplace" "Power" "100 W" "200 W")
	// AttReplace "Power" "100 W" "200 W"
	static void ArxTest_AttReplace(void)
	{
		// Get user selection point in second document
		ads_point pt;

		TCHAR tagNameBuf[133];
		if (acedGetString(Adesk::kFalse, _T("\nEnter tag name: "), tagNameBuf) != RTNORM)
		{
			acutPrintf(ACRX_T("\nInvalid tag name."));
			return;
		}

		TCHAR oldAttTextBuf[133];
		if (acedGetString(Adesk::kFalse, _T("\nEnter old attribute text to find : "), oldAttTextBuf) != RTNORM)
		{
			acutPrintf(ACRX_T("\nInvalid attribute text to find."));
			return;
		}

		TCHAR newAttTextBuf[133];
		if (acedGetString(Adesk::kFalse, _T("\nEnter new attribute text to replace with : "), newAttTextBuf) != RTNORM)
		{
			acutPrintf(ACRX_T("\nInvalid attribute text to replace with."));
			return;
		}

		// Find and replace attribute value
		CUtils::ChangeAttributeValue(tagNameBuf, oldAttTextBuf, newAttTextBuf);
	}

} ;

//-----------------------------------------------------------------------------
IMPLEMENT_ARX_ENTRYPOINT(CArxTest1App)

ACED_ARXCOMMAND_ENTRY_AUTO(CArxTest1App, ArxTest, _AttReplace, AttReplace, ACRX_CMD_MODAL, NULL)